USE COWS
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

--DROP TABLE dbo.[LK_IP_MSTR]
 --DROP TABLE dbo.[IP_ACTY]
 --DROP TABLE dbo.[IP_MSTR]
 --DROP TABLE dbo.[NID_ACTY]
 --DROP TABLE dbo.[NAT_SIP_ACTY]

--Lookup table to define the start/end ip ranges and corresponding source system
CREATE TABLE [dbo].[LK_IP_MSTR](
	[ID] [smallint] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[STRT_IP_ADR] [VARCHAR](15) NOT NULL,
	[END_IP_ADR] [VARCHAR](15) NOT NULL,
	[SYSTM_CD] [VARCHAR](10) NOT NULL,
	[REC_STUS_ID] [smallint] NOT NULL CONSTRAINT [DF_RECSTUSID_LK_IP_MSTR_1] DEFAULT ((1)), --Active/InActive(251/252)
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[CREAT_DT] [smalldatetime] NOT NULL CONSTRAINT [DF_getdate_LK_IP_MSTR_1] DEFAULT  getdate(),
	[MODFD_DT] [smalldatetime] NULL,
 CONSTRAINT [PK_LK_IP_MSTR] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[LK_IP_MSTR]  WITH NOCHECK ADD  CONSTRAINT [FK01_LK_IP_MSTR] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_STUS] ([STUS_ID])
GO

ALTER TABLE [dbo].[LK_IP_MSTR] CHECK CONSTRAINT [FK01_LK_IP_MSTR]
GO

ALTER TABLE [dbo].[LK_IP_MSTR]  WITH NOCHECK ADD  CONSTRAINT [FK02_LK_IP_MSTR] FOREIGN KEY([MODFD_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[LK_IP_MSTR] CHECK CONSTRAINT [FK02_LK_IP_MSTR]
GO

ALTER TABLE [dbo].[LK_IP_MSTR]  WITH NOCHECK ADD  CONSTRAINT [FK03_LK_IP_MSTR] FOREIGN KEY([CREAT_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[LK_IP_MSTR] CHECK CONSTRAINT [FK03_LK_IP_MSTR]
GO

ALTER TABLE [dbo].[LK_IP_MSTR] ADD CONSTRAINT FK04_LK_IP_MSTR
CHECK 
(
 ((ParseName(STRT_IP_ADR, 4) >= 0) and (ParseName(STRT_IP_ADR, 4) <= 255))
 AND ((ParseName(STRT_IP_ADR, 3) >= 0) and (ParseName(STRT_IP_ADR, 3) <= 255))
 AND ((ParseName(STRT_IP_ADR, 2) >= 0) and (ParseName(STRT_IP_ADR, 2) <= 255))
 AND ((ParseName(STRT_IP_ADR, 1) >= 0) and (ParseName(STRT_IP_ADR, 1) <= 255))
)
GO

ALTER TABLE [dbo].[LK_IP_MSTR] ADD CONSTRAINT FK05_LK_IP_MSTR
CHECK 
(
 ((ParseName(END_IP_ADR, 4) >= 0) and (ParseName(END_IP_ADR, 4) <= 255))
 AND ((ParseName(END_IP_ADR, 3) >= 0) and (ParseName(END_IP_ADR, 3) <= 255))
 AND ((ParseName(END_IP_ADR, 2) >= 0) and (ParseName(END_IP_ADR, 2) <= 255))
 AND ((ParseName(END_IP_ADR, 1) >= 0) and (ParseName(END_IP_ADR, 1) <= 255))
)
GO


--Master Table to capture all IPs(IPv4) and respective status for NID management
CREATE TABLE [dbo].[IP_MSTR](
	[IP_MSTR_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[IP_ADR] [VARCHAR](15) NOT NULL,
	[REC_STUS_ID] [smallint] NOT NULL CONSTRAINT [DF_RECSTUSID_IP_MSTR_1] DEFAULT ((252)), --Active/Used/Disc/90Dayhold(251/253/254/255)
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[CREAT_DT] [smalldatetime] NOT NULL CONSTRAINT [DF_getdate_IP_MSTR_1] DEFAULT  getdate(),
	[MODFD_DT] [smalldatetime] NULL,
 CONSTRAINT [PK_IP_MSTR] PRIMARY KEY CLUSTERED 
(
	[IP_MSTR_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[IP_MSTR]  WITH NOCHECK ADD  CONSTRAINT [FK01_IP_MSTR] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_STUS] ([STUS_ID])
GO

ALTER TABLE [dbo].[IP_MSTR] CHECK CONSTRAINT [FK01_IP_MSTR]
GO

ALTER TABLE [dbo].[IP_MSTR]  WITH NOCHECK ADD  CONSTRAINT [FK02_IP_MSTR] FOREIGN KEY([MODFD_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[IP_MSTR] CHECK CONSTRAINT [FK02_IP_MSTR]
GO

ALTER TABLE [dbo].[IP_MSTR]  WITH NOCHECK ADD  CONSTRAINT [FK03_IP_MSTR] FOREIGN KEY([CREAT_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[IP_MSTR] CHECK CONSTRAINT [FK03_IP_MSTR]
GO

ALTER TABLE [dbo].[IP_MSTR] ADD CONSTRAINT FK04_IP_MSTR
CHECK 
(
 ((ParseName(IP_ADR, 4) >= 0) and (ParseName(IP_ADR, 4) <= 255))
 AND ((ParseName(IP_ADR, 3) >= 0) and (ParseName(IP_ADR, 3) <= 255))
 AND ((ParseName(IP_ADR, 2) >= 0) and (ParseName(IP_ADR, 2) <= 255))
 AND ((ParseName(IP_ADR, 1) >= 0) and (ParseName(IP_ADR, 1) <= 255))
)
GO

ALTER TABLE [dbo].[IP_MSTR] ADD CONSTRAINT [UX01_IP_MSTR] UNIQUE NONCLUSTERED 
(
	[IP_ADR] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

--Activity/History Table to capture all NID Serial# assignments
--1) Inserted with a FSA_CPE_LINE_ITEM_ID and NID SN.
--2) EventID is assigned and hostname is updated in the table when a event is completed.
--3) New Order uses existing NID SN, old NID SN+FSA_CPE_LINE_ITEM_ID combo record gets updated to Inactive(252) and a New record with NID SN and new FSA_CPE_LINE_ITEM_ID is created.
--4) New record with updated NID SN, if at all a event updates the NID SN. In that scenario, FSA_CPE_LINE_ITEM_ID needs to be copied to the new record.
--5) REC_STUS_ID is 251 by default to denote that it is active record, if it is scenario 3) then prior records rec_stus_id gets updated to 252.
--6) Note: Ideally NID Serial# is 1-1 relation with IP_MSTR/IP_ADR but some disconnect scenarios BPM can send diff. NID SN+IP Address combination in their --view (NSF_COWS_NID_DETL)
CREATE TABLE [dbo].[NID_ACTY](
	[NID_ACTY_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[NID_SERIAL_NBR] [varchar](100) NOT NULL,
	[NID_HOST_NME] [varchar](100) NULL,
	[FSA_CPE_LINE_ITEM_ID] [int] NULL,
	[EVENT_ID] [int] NULL,
	[M5_ORDR_NBR] VARCHAR(50) NULL,
	[DD_APRVL_NBR] VARCHAR(200) NULL,
	[H6] CHAR(9) NULL,
	[REC_STUS_ID] [smallint] NOT NULL CONSTRAINT [DF_RECSTUSID_NID_ACTY_1] DEFAULT ((251)), --Active/InActive(251/252)
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_NID_ACTY_1] DEFAULT  getdate(),
	[MODFD_DT] [datetime] NULL,
 CONSTRAINT [PK_NID_ACTY] PRIMARY KEY CLUSTERED 
(
	[NID_ACTY_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]) ON [PRIMARY]
GO


ALTER TABLE [dbo].[NID_ACTY]  WITH CHECK ADD  CONSTRAINT [FK01_NID_ACTY] FOREIGN KEY([FSA_CPE_LINE_ITEM_ID])
REFERENCES [dbo].[FSA_ORDR_CPE_LINE_ITEM] ([FSA_CPE_LINE_ITEM_ID])
GO

ALTER TABLE [dbo].[NID_ACTY] CHECK CONSTRAINT [FK01_NID_ACTY]
GO

ALTER TABLE [dbo].[NID_ACTY]  WITH CHECK ADD  CONSTRAINT [FK02_NID_ACTY] FOREIGN KEY([EVENT_ID])
REFERENCES [dbo].[EVENT] ([EVENT_ID])
GO

ALTER TABLE [dbo].[NID_ACTY] CHECK CONSTRAINT [FK02_NID_ACTY]
GO

ALTER TABLE [dbo].[NID_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK03_NID_ACTY] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_STUS] ([STUS_ID])
GO

ALTER TABLE [dbo].[NID_ACTY] CHECK CONSTRAINT [FK03_NID_ACTY]
GO

ALTER TABLE [dbo].[NID_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK04_NID_ACTY] FOREIGN KEY([MODFD_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[NID_ACTY] CHECK CONSTRAINT [FK04_NID_ACTY]
GO

ALTER TABLE [dbo].[NID_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK05_NID_ACTY] FOREIGN KEY([CREAT_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[NID_ACTY] CHECK CONSTRAINT [FK05_NID_ACTY]
GO

CREATE NONCLUSTERED INDEX [IX01_NID_ACTY] ON [dbo].[NID_ACTY]
(
	[FSA_CPE_LINE_ITEM_ID]
)
WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

--Activity/History Table to capture all SIP/NAT Activity assignments
CREATE TABLE [dbo].[NAT_SIP_ACTY](
	[NAT_SIP_ACTY_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[DD_APRVL_NBR] VARCHAR(200) NULL,
	[H6] CHAR(9) NULL,
	[REC_STUS_ID] [smallint] NOT NULL CONSTRAINT [DF_RECSTUSID_NAT_SIP_ACTY_1] DEFAULT ((251)), --Active/InActive(251/252)
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_NAT_SIP_ACTY_1] DEFAULT  getdate(),
	[MODFD_DT] [datetime] NULL,
 CONSTRAINT [PK_NAT_SIP_ACTY] PRIMARY KEY CLUSTERED 
(
	[NAT_SIP_ACTY_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[NAT_SIP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK01_NAT_SIP_ACTY] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_STUS] ([STUS_ID])
GO

ALTER TABLE [dbo].[NAT_SIP_ACTY] CHECK CONSTRAINT [FK01_NAT_SIP_ACTY]
GO

ALTER TABLE [dbo].[NAT_SIP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK02_NAT_SIP_ACTY] FOREIGN KEY([MODFD_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[NAT_SIP_ACTY] CHECK CONSTRAINT [FK02_NAT_SIP_ACTY]
GO

ALTER TABLE [dbo].[NAT_SIP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK03_NAT_SIP_ACTY] FOREIGN KEY([CREAT_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[NAT_SIP_ACTY] CHECK CONSTRAINT [FK03_NAT_SIP_ACTY]
GO

--Activity/History Table to capture all NID IP(IPv4) assignments
--Individual NID_ACTY transactions creates new records and old records for that IP_ADR/IP_MSTR_ID will be moved to InActive
CREATE TABLE [dbo].[IP_ACTY](
	[IP_ACTY_ID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[IP_MSTR_ID] [int] NOT NULL,
	[NID_ACTY_ID] [int] NULL,
	[NAT_SIP_ACTY_ID] [int] NULL,
	[REC_STUS_ID] [smallint] NOT NULL CONSTRAINT [DF_RECSTUSID_IP_ACTY_1] DEFAULT ((251)), --Active/InActive(251/252)
	[CREAT_BY_USER_ID] [int] NOT NULL,
	[MODFD_BY_USER_ID] [int] NULL,
	[CREAT_DT] [datetime] NOT NULL CONSTRAINT [DF_getdate_IP_ACTY_1] DEFAULT  getdate(),
	[MODFD_DT] [datetime] NULL,
 CONSTRAINT [PK_IP_ACTY] PRIMARY KEY CLUSTERED 
(
	[IP_ACTY_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[IP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK01_IP_ACTY] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_STUS] ([STUS_ID])
GO

ALTER TABLE [dbo].[IP_ACTY] CHECK CONSTRAINT [FK01_IP_ACTY]
GO

ALTER TABLE [dbo].[IP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK02_IP_ACTY] FOREIGN KEY([MODFD_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[IP_ACTY] CHECK CONSTRAINT [FK02_IP_ACTY]
GO

ALTER TABLE [dbo].[IP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK03_IP_ACTY] FOREIGN KEY([CREAT_BY_USER_ID])
REFERENCES [dbo].[LK_USER] ([USER_ID])
GO

ALTER TABLE [dbo].[IP_ACTY] CHECK CONSTRAINT [FK03_IP_ACTY]
GO

ALTER TABLE [dbo].[IP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK04_IP_ACTY] FOREIGN KEY([NID_ACTY_ID])
REFERENCES [dbo].[NID_ACTY] ([NID_ACTY_ID])
GO

ALTER TABLE [dbo].[IP_ACTY] CHECK CONSTRAINT [FK04_IP_ACTY]
GO

ALTER TABLE [dbo].[IP_ACTY]  WITH NOCHECK ADD  CONSTRAINT [FK05_IP_ACTY] FOREIGN KEY([NAT_SIP_ACTY_ID])
REFERENCES [dbo].[NAT_SIP_ACTY] ([NAT_SIP_ACTY_ID])
GO

ALTER TABLE [dbo].[IP_ACTY] CHECK CONSTRAINT [FK05_IP_ACTY]
GO

CREATE NONCLUSTERED INDEX [IX01_IP_ACTY] ON [dbo].[IP_ACTY]
(
	[NID_ACTY_ID]
)
WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX02_IP_ACTY] ON [dbo].[IP_ACTY]
(
	[IP_MSTR_ID]
)
WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX03_IP_ACTY] ON [dbo].[IP_ACTY]
(
	[NAT_SIP_ACTY_ID]
)
WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

ALTER TABLE dbo.MDS_EVENT_NTWK_TRPT
DROP COLUMN SALS_ENGR_PHN
GO

ALTER TABLE dbo.MDS_EVENT_NTWK_TRPT
DROP COLUMN SALS_ENGR_EMAIL
GO

ALTER TABLE dbo.MDS_EVENT_NTWK_TRPT
DROP COLUMN PL_NBR
GO

ALTER TABLE dbo.MDS_EVENT_NTWK_TRPT
ADD BDWD_NME VARCHAR(20) NULL
GO

ALTER TABLE dbo.MDS_EVENT
ADD IPM_DES VARCHAR(500) NULL,
RLTD_CMPS_NCR_CD	BIT NULL,
RLTD_CMPS_NCR_NME	VARCHAR(200) NULL
GO